﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;

namespace Malovani
{
    public partial class MainWindow : Form
    {
        public MainWindow()
        {
            InitializeComponent();
            toolComboBox.SelectedIndex = 1;

            int W = pictureBox.Width;
            int H = pictureBox.Height;
            Bitmap b = new Bitmap(W, H);
            Graphics g = Graphics.FromImage(b);
            g.FillRectangle(Brushes.White, 0, 0, W, H);
            pictureBox.Image = b;

            // propertyGrid1.SelectedObject = myPanel1;
            selector.SelectedIndex = 0;

            // myPanel1.button1.Click += newColorPanelToolStripMenuItem_Click;

            // foreach (Control c in splitContainer2.Panel2.Controls)
               //  if (c is MyPanel)
                  //  (c as MyPanel).button1.Text = "***";
            
        }

        private void selector_SelectedIndexChanged(object sender, EventArgs e)
        {
            /*
            if (selector.SelectedIndex == 0)
                propertyGrid1.SelectedObject = myPanel1;
            else if (selector.SelectedIndex == 1)
                propertyGrid1.SelectedObject = myPanel1.button1;
            */
        }

        List <MyPanel> panels = new List<MyPanel> ();

        public void registerMyPanel (MyPanel p)
        {
            bool found = false;
            foreach (MyPanel t in panels)
                if (t == p)
                    found = true;

            if (! found)
            {
               panels.Add (p);

               TreeNode n = new TreeNode ();
               n.Text = "panel";
               n.Tag = p;
               treeView1.Nodes.Add (n);
            }
        }

        private int X0, Y0;
        private bool stisknuto = false;

        private void pictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            stisknuto = true;
        }

        private void pictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            if (stisknuto)
            {
                int X1 = e.X;
                int Y1 = e.Y;
                int W = Math.Abs(X1 - X0);
                int H = Math.Abs(Y1 - Y0);
                int X = X0 < X1 ? X0 : X1;
                int Y = Math.Min(Y0, Y1);

                Pen p = new Pen(penColor);

                Graphics g = Graphics.FromHwnd(pictureBox.Handle);

                g.DrawImage(pictureBox.Image, new Point(0, 0));
                g.DrawRectangle(p, X, Y, W, H);
            }
        }

        private void pictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            if (stisknuto)
            {
                stisknuto = false;

                int X1 = e.X;
                int Y1 = e.Y;

                int W = Math.Abs (X1 - X0);
                int H = Math.Abs (Y1 - Y0);

                int X = X0 < X1 ? X0 : X1;
                int Y = Math.Min(Y0, Y1);

                Brush b = null;

                if (checkBox.Checked)
                   // using System.Drawing.Drawing2D;
                   b = new LinearGradientBrush
                          (new Point(X,Y),
                           new Point(X+W-1, Y+H-1),
                           color,
                           color2);
                else
                   b = new SolidBrush(color);

                Pen p = new Pen(penColor);
                p.Width = 5;

                Graphics g = Graphics.FromImage(pictureBox.Image);

                // if (toolComboBox.Text == "Rectangle")
                if (toolComboBox.SelectedIndex == 0)
                {
                    g.FillRectangle(b, X, Y, W, H);
                    g.DrawRectangle(p, X, Y, W, H);
                }
                // else if (toolComboBox.Text == "Ellipse")
                else if (toolComboBox.SelectedIndex == 1)
                {
                    g.FillEllipse(b, X, Y, W, H);
                    g.DrawEllipse(p, X, Y, W, H);
                }
                else if (toolComboBox.SelectedIndex == 2)
                {
                    float start = 0;
                    float end = (float)numericField.Value;
                    g.FillPie(b, X, Y, W, H, start, end);
                    g.DrawPie(p, X, Y, W, H, start, end);
                }
                
                pictureBox.Invalidate();
            }
        }

        private Color color = Color.Yellow;
        private Color color2 = Color.Red;
        private Color penColor = Color.Blue;

        private void panel1_MouseDown(object sender, MouseEventArgs e)
        {
            Control p = (Control) sender;
            // Control p = sender as Control;
            if (e.Button == MouseButtons.Left)
                color = p.BackColor;
            else if (e.Button == MouseButtons.Middle)
                color2 = p.BackColor;
            else if (e.Button == MouseButtons.Right)
                penColor = p.BackColor;
        }

        private void panel1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            Control p = (Control)sender;
            colorDialog.Color = p.BackColor;
            if (colorDialog.ShowDialog() == DialogResult.OK)      
            {
               p.BackColor = colorDialog.Color;
               color = p.BackColor;
            }
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openDialog.ShowDialog() == DialogResult.OK)
            {
                Bitmap b = new Bitmap(openDialog.FileName);

                int W = Math.Max(b.Width, pictureBox.Image.Width);
                int H = Math.Max(b.Height, pictureBox.Image.Height);
                Bitmap bb = new Bitmap(W, H);
                Graphics gg = Graphics.FromImage(bb);
                gg.FillRectangle(Brushes.White, 0, 0, W, H);
                gg.DrawImage(b, new Point(0, 0));
                
                pictureBox.Image = bb;
                pictureBox.Invalidate();
            }
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (saveDialog.ShowDialog() == DialogResult.OK)
            {
                if (saveDialog.FilterIndex == 1)
                   // using System.Drawing.Imaging;
                   pictureBox.Image.Save(saveDialog.FileName, ImageFormat.Jpeg);
                else
                   pictureBox.Image.Save(saveDialog.FileName);
            }
        }

        private void pictureBox_SizeChanged(object sender, EventArgs e)
        {
            int W = Math.Max (pictureBox.Width, pictureBox.Image.Width);
            int H = Math.Max (pictureBox.Height, pictureBox.Image.Height);
            Bitmap b = new Bitmap(W, H);
            Graphics g = Graphics.FromImage(b);
            g.FillRectangle(Brushes.White, 0, 0, W, H);
            // g.FillRectangle(Brushes.Red, W-1, H-1, 1, 1);
            g.DrawImage(pictureBox.Image, new Point(0, 0));
            pictureBox.Image = b;
        }

        int cnt = 0;

        public void newColorPanelToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Panel p = new Panel ();
            cnt ++;
            // p.Parent = toolPanel;
            toolPanel.Controls.Add (p);
            p.BackColor = Color.Yellow;
            p.Width = panel3.Width;
            p.Height = panel3.Height;
            p.Top = panel3.Top;
            p.Left = panel3.Left + cnt * (panel3.Left - panel2.Left);
            p.MouseDown += panel1_MouseDown;
            p.MouseDoubleClick += panel1_MouseDoubleClick;
        }

        private void newAreaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MyPanel p = new MyPanel();
            pictureBox.Controls.Add (p);
        }

        private void testToolStripMenuItem_Click(object sender, EventArgs e)
        {
            /*
            TreeNode n = new TreeNode();
            n.Text = "New item";
            treeView1.Nodes.Add (n);

            TreeNode n2 = new TreeNode();
            n2.Text = "New subitem item";
            n.Nodes.Add (n2);
            */
        }


    }
}
