﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Malovani
{
    public partial class MyPanel : UserControl
    {
        public MyPanel()
        {
            InitializeComponent();
            MyPanel_ParentChanged(null, null);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (openDialog.ShowDialog() == DialogResult.OK)
            {
                Bitmap b = new Bitmap(openDialog.FileName);
                this.BackgroundImage = b;
                BackgroundImageLayout = ImageLayout.Stretch;
            }

        }

        int X0, Y0;
        bool stisknuto;

        private void MyPanel_MouseDown(object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            stisknuto = true;
        }

        private void MyPanel_MouseMove(object sender, MouseEventArgs e)
        {
            if (stisknuto)
            {
                if (e.Button == MouseButtons.Left)
                {
                    int x = Location.X + e.X - X0;
                    int y = Location.Y + e.Y - Y0;
                    Location = new Point(x, y);
                }
                else if (e.Button == MouseButtons.Right)
                {
                    int w = Size.Width + e.X - X0;
                    int h = Size.Height + e.Y - Y0;
                    Size = new Size(w, h);
                    X0 = e.X;
                    Y0 = e.Y;
                }
            }
        }

        private void MyPanel_MouseUp(object sender, MouseEventArgs e)
        {
            stisknuto = false;
        }

        private void MyPanel_ParentChanged(object sender, EventArgs e)
        {
            Control p = this.Parent;
            while (p != null && !(p is MainWindow))
                p = p.Parent;
            if (p != null)
               (p as MainWindow).registerMyPanel(this);
        }


    }
}
